Subject: [bug#62202] [PATCH 0/21] Juliahub import script.

From: Ludovic Courtès <[email-masked]>
Date: Tue, 08 Aug 2023 17:24:38 +0200

Hello Nicolas & Simon!

What should we do about this importer?  Looks like useful code to me!

Thanks,
Ludo’.

Ludovic Courtès <[email-masked]> skribis:

> Hi!
>
> Nicolas Graves <[email-masked]> skribis:
>
>>  Took me quite more time than I would've liked, but I have a usable
>>  juliahub scheme import script!
>>
>>  It seems there's still one edge case that isn't covered and revolves
>>  around when Julia packagers don't properly tag their git repos (I've
>>  only seen the case with SnoopPrecompile). There's the possibility to
>>  rely on tree commit hashes from the General repository (since this is a
>>  valid way to identify/store a git repo), but that needs some major
>>  changes in the way latest-repository-commit works. Otherwise, it needs
>>  to be done by hand. It might also not work for subpackages in
>>  directories that are up-to-date on juliahub but not yet on github, I
>>  haven't met this case yet.
>>
>>  I'm sending a patch series in the coming minutes.
>>
>> It's detailed since I haven't swauased all commits, for readability, but
>> I can squash it further if necessary.
>
> I’ll let Simon comment on the actual code since I’m not a Julia person.
> :-)
>
> Some more general comments:
>
>   • Please make sure to document it in ‘doc/guix.texi’ under “Invoking
>     guix import”, following the same template as the others there.
>
>   • Please write ‘tests/juliahub.scm’.  I recommend the same strategy as
>     ‘tests/cpan.scm’, which is to mock the upstream HTTP server.
>
>   • Prefer (srfi srfi-41) over (ice-9 streams) (see rationale at
>     <https://srfi.schemers.org/srfi-41/srfi-41.html>).
>
>   • Prefer (srfi srfi-71) over (srfi srfi-11) for multiple-value
>     bindings.
>
> Thanks,
> Ludo’.